#lesson.1.r
#functions list: c, cbind, rbind, seq, rep, sort, trunc, ceiling

#after the R-prompt
#to start type r
#to quit type q 
#to write a result type w 
#to write a result and quit type wq 

#to define a value called x
x <- 10
#to display a value and functions of the value
x
x^2
x^0.5
x+10

x <- c(10,20,30,40,50)
x
x^2
x^0.5
x+10
xx <- x+10
xx
xx^2
xx^0.5
xx+x

#c -- combine
c1 <- c(10,20,30,40)
c1
c2 <- c(10,20,30,40)/2
c2
x <- cbind(c1,c2)  #combines columns
x
x^2
x^0.5
x+10
xx/10
#note:  the R-function is always applied to each element 
#within a sequence or an array

#more examples
x <- c(2,4,6,8)
y <- c(x,x,x)
y
x0 <- c(0,x)
x0
new <- c(0,x,10)
new

#cbind and rbind combine values into array rows or columns 
rbind(c(1,2,3),c(4,5,6),c(7,8,9)) #rows
cbind(c(1,2,3),c(4,5,6),c(7,8,9)) #columns

#seq -- generates sequence of values by specific units -- seq(from, to, by)
seq(0,8,2)
seq(0,1,0.1)
seq(0,1,length=5)
time <- seq(0,1,length=12)
time

#alternatives
seq(0,10,1)
0:10
seq(10,0,-1)
10:0
seq(0,100,length=11)  #10 = interval width
seq(0,100,length=10)  #9  = interval width
seq(0,100,length=9)   #8  = interval width

#subscript -- location of specific values in a sequence/vector
#input data
z <- c(10,20,30,40,50,60,50,40,30,20,10)
z
rbind(1:11,z)
z[7]
#z[1,2,3]
#Error in z[1, 2, 3] incorrect number of dimensions
#Execution halted

z[c(1,2,3)]
z[c(1,3,5,7,9,11,2,4,6,8,10)]
z[c(1,11)]
z[1:6]
z[6:1]
z[c(1,1,2,2,3,3,4,4,5,5,6,6,7,7)]

#recoding as an application of subscript
#data value 1,2,3 and 4 represent 1,000, 2,000, 5,000 10,000
data <- c(4,1,3,2,4,3,1,1,2,3,4)
data
values <- c(1,2,5,10)*1000
values
#recoded
income <- values[data]
income

#true/false logic
#& is symbol for "and"
#! is symbol for "not equal" 
z <- c(10,20,30,40,50,60,50,40,30,20,10)
z<50 & z!=10  
z[z<50 & z!=10] #eliminates the "FALSE" values
z!=30 & z!=50 
z[z!=30 & z!=50] 
#| is symbol for "or"
z[z!=30 | z>40] 
z[z<=20 | z>=60] 
z<30 | z>40
z[z<30 | z>40]
!(z<30 | z>40)
z[!(z<30 | z<40)]

#function rep generates repeated values  -- rep(values,times)
rep(0,10)
rep(c(1,2,3),5)
rep(c(4,3,2,1),c(1,2,3,4))
rep(4:1,1:4)
rep(1:5,rep(3,5))
rep(1:5,3)
sort(rep(1:5,3))

#R-software functions
x <- c(-1,0,1,2,3,4)
log(x)
#NaN = not a number
log10(x)
log10(x)/log(x)
exp(x)
sign(x)
factorial(x)
sin(x)
abs(x)
sqrt(x)

#more R-software functions
#data
y <- c(1,2,6,1,4,5,4)/2
y

length(y)
prod(y)
sum(y)
cumsum(y)
cumprod(y)
diff(y)
rev(y)
sort(y)
rank(y)

#R-functions can be "nested"
sum(diff(y))
prod(diff(y))
cumprod(y)/sum(y)
sqrt(sum(cumprod(y)/sum(y)))

#trunc -- produces the largest integer less than a value
#ceiling -- produces the smallest integer greater than a value
c(sqrt(5),trunc(sqrt(5)),ceiling(sqrt(5)))
c(pi,trunc(pi),ceiling(pi))
cbind(1:10/3,trunc(1:10/3),ceiling(1:10/3))

#even/odd
1:10/2-trunc(1:10/2)

