#lesson.5.r
#function list:  plot, points, text, legend, abline, lines, persp, for

#plot a series of confidence intervals
#details of the application plot() --- lesson.9

#function: ci.plot
ci.plot <- function(means,se){
par(pty="s")  #square plot
p <- 0.975
upper <- means+qnorm(p)*se
lower <- means-qnorm(p)*se
n <- length(means)
plot(1:n,upper,pch="+",
   ylim=c(min(lower),max(upper)),
   xlim =c(0.8,n+0.2),
   xlab="groups",
   ylab="confidence intervals",
   main="Series of mean values and confidence intervals")
points(1:n,lower,pch="+")
points(1:n,means,pch="o")

for(i in 1:n) {
  lines(c(i,i),c(lower[i],upper[i]))

text(1:n+0.15,means,round(means,1),cex=0.75)
text(1:n+0.15,upper,round(upper,1),cex=0.75)
text(1:n+0.15,lower,round(lower,1),cex=0.75)
}
}

#test data
xbar <- c(2,4,6,8)
s <-  c(0.5,0.7,0.9,1.0)
ci.plot(xbar,s)

#generates n=200 points in a square one unit by one unit
par(pty="s") #generates a square x/x-plot
n <- 200
x <- runif(n,0,1)
y <- runif(n,0,1)
plot(0,0,type="n",xlim=c(0,1),ylim=c(1,0),axes=FALSE,xlab="",
ylab="",xaxt="n",yaxt="n")
points(x,y,cex=0.8,pch=16)
abline(v=(0:10)/10)
abline(h=(0:10)/10)
title("200 random points",cex=1.2) #cex increase font size


#counts points per subinterval
X <- findInterval(x,seq(0,1,.1))
Y <- findInterval(y,seq(0,1,.1))
d <- table(Y,X)
tab <- table(d)
tab
#comparison of data generated values to a Poisson distribution (parameter = 2)
P <- c(dpois(0:5,2),1-sum(dpois(0:5,2))) #expected probabilities
p <- tab/sum(tab) #estimated probabilities
ex <- n*P
est <- n*p
round(cbind(p,P,est,ex),3)

#for loop for a sequence of r-commands
#for (index in range) {contains r-commands or r-functions)}

#example 1
x <- 5:1
for(i in c(1,2,3,4,5) ) {print(x^i)}

#example 2
x <- c(1,0,2,0,3,0,4,0,5,0,6,0,5,0,4,0,3,0,2,0,1,0)
y <- NULL #identifies the array used in the loop
k <- 0
for(i in 1:length(x)) {
if(x[i]==0) next  #skip to next value of i
if(x[i]<x[i+1]) break  #exit loop
k <- k+1
y[k] <- 1/x[i]
}
round(y,3)

#example 3
#distribution of the range
iter <- 100
R <- NULL
for(k in 1:iter) {
d1 <- rnorm(1,10,2)
d2 <- rnorm(1,15,2)
R[k] <- d2-d1
}
round(cbind(mean(R),var(R),sd(R),min(R),max(R)),3)
summary(R)


#example 4
#tukey.s quick test samples A versus B
#data
B <- c(132,140,149,155,172,179,181,182,185,189,120,220,125,
247,254,255)
A <- c(176,177,277,180,192,212,209,210,211,223,227,257,238,
239,242,271,274,325)

iter <- 2000
T <- NULL  #will contain results from quick tests
for(kk in 1:iter) {
b <- sample(B,length(B),replace=TRUE)
a <- sample(A,length(A),replace=TRUE)
T[kk] <- length(b[b<min(a)])+length(a[a>max(b)])
}
summary(T)
1-sum(ifelse(T>7,1,0))/iter  #p-value


#example 5  -- Fibonacci series
#1 2 3 5 8 13 21 34
n <- 18
f <- NULL
f[1] <- 1
f[2] <- 1
for(i in 1:(n-2)) {
f[i+2] <- f[i]+f[i+1]
}
f
for(i in 1:(n-2)) {print(f[i+1]/f[i])}
#golden mean
(1+sqrt(5))/2

