#lesson.6.r
#Four examples of R-code

#Example 1
#selection of random.days
m.names <- c("January","February","March","April","May","June","July","August","September","October","November","December")
months.days <- cbind(31,28,31,30,31,30,31,31,30,31,30,31)
days.lst <- c(1:31,1:28,1:31,1:30,1:31,1:30,1:31,1:31,1:30,1:31,1:30,1:31)
m.list <- rep(m.names,months.days)
k <- 10 #number of random days
days <- sample(1:365,k,replace=TRUE)
cbind(days,m.list[days],days.lst[days])

#Example 2
#mean, sample size and standard errors from variable length data
data <- c(-999,1,2,1,4,-999,2,5,2,3,2,1,-999,2,4,7,2,-999,2,7,2,3,1,-999,1,1,1,2,-999,1,2,1,4,5,1,7,2,1,0)
data

locate <- (1:length(data))[data==-999]  #locates break points
locate
for(i in 1:(length(locate)-1)) {
xtemp <- data[(locate[i]+1):(locate[i+1]-1)]
print(paste("Mean =",round(mean(xtemp),3)))
print(paste("sample size =",length(xtemp)))
print(paste("Standard error =",round(sd(xtemp/sqrt(length(xtemp))),3)))}
#note: paste combines output results with labels`

#note:
x <- c(1,1,2,2,3,3,4,4,5,5)
unique(x)

#Example 3
#At McDonald's you can order Chicken McNuggets 
#in boxes of 6,9 or 12.  By ordering two boxes of 6, 
#you can get 12. But you cannot order 13 since 
#no combination of 6, 9 or 20 adds up to 13.  
#What is the greatest number of McNuggets that you can not order?

unique(sort(outer(outer(6*(0:7),9*(0:4),"+"),20*(0:20),"+")))[1:50]

#answer: 43 -- greater than 44 every possible combination exists


#Example 4
#Comparison of the two-sample classic t-test and the Wilcoxon test

#Data 1
x <- c(4,21,28,35,66)
y <- c(10,42,71,77,90)

#Detailed code for a t-test comparison of two means

#Data 2
#A/B behavior and cholesterol
x.in <- c(344,0,246,0,224,1,242,0,252,1,233,1,224,0,
239,1,252,0,202,1,291,1,212,0,239,1,153,0,218,1,
312,1,188,0,254,1,183,0,202,0,185,0,250,0,169,0,
234,1,212,1,250,1,197,1,226,0,137,0,325,1,263,0,
148,0,175,0,181,1,194,0,246,1,268,1,276,1,248,1,213,0)
xtemp <-x.in[seq(1,length(x.in),2)]
id <- x.in[seq(2,length(x.in),2)]
x <- xtemp[id==1]  #type B
y <- xtemp[id==0]  #type A

#summary values
n1 <- length(x)
n2 <- length(y)
n <- n1+n2
xbar <- mean(x)
vx <- var(x)
ybar <- mean(y)
vy <- var(y)
d <- ybar-xbar
cbind(xbar,ybar,vx,vy,d)

#t.test
vy <- var(y)
v <- ((n1-1)*var(x)+(n2-1)*var(y))/(n-2)
V <- v*(1/n1+1/n2)
d <- xbar-ybar
t <- d/sqrt(V)
cbind(t,2*(1-pt(z,35)))

t.test(x,y,var.equal=TRUE)
wilcox.test(x,y)

#normal approximation for the Wilcoxon test
ex <- n1*(n+1)/2
vv <- n1*n2*(n+1)/12
U <- wilcox.test(x,y)$statistic
W <- U+n1*(n1+1)/2
z <- (W-ex)/sqrt(vv)
pvalue <- 2*(1-pnorm(z))
cbind(ex,W,vv,z,pvalue)

#Mann-Whitney  -- P(random y < random x)?
P <- U/(n1*n2)
vp <- vv/(n1*n2)^2
z <- (P-0.5)/sqrt(vp)
pvalue <- 2*(1-pnorm(z))
cbind(P,vp,z,pvalue)
