
#lesson.7.r
#function list:  aggregate, duplicate, unique, density

#aggregate
IQ <- rnorm(100,100,20)
wt <- rnorm(100,170,2)
ht <- rnorm(100,70,4)
wt.cat <- findInterval(wt,c(0,169,171,300))
table(wt.cat)
ht.cat <- findInterval(ht,c(0,67,72,100))
table(ht.cat)
table(wt.cat,ht.cat)
N <- aggregate(IQ,list(wt.cat,ht.cat),length)
N
xbar <- aggregate(IQ,list(wt.cat,ht.cat),mean)
xbar
sd <- aggregate(IQ,list(wt.cat,ht.cat),sd)
sd
xbar/sd


#duplicated and unique
x0 <- c(1,2,3,4,5,4,7,8,9,9,1,2)
loc <- duplicated(x0) #locates duplicates
loc
x0[loc]
unique(x0) #displays unique values

#density.r -- yields smoothed representation of a data derived distribution
n <- 100
z <- rnorm(n)
plot(density(z,0.5),xlab="normally distributed values",ylim=c(0,.5),main="Three density plots")
abline(h=0)
n <- 20
z <- rnorm(n)
lines(density(z,0.5),type="l",lty=2)
n <- 100
z <- rnorm(n)
lines(density(z,0.5),type="l",lty=3)
legend(-3,0.5,c("n = 10","n = 20","n = 200"),lty=1:3)

#test.variance.r
#approximate variance = 1/(180*n)

#variance of uniform distributed value
n <- 50
iter <- 5000
v.temp <- matrix(runif(iter*n),n,iter)
dim(v.temp)
v <- apply(v.temp,2,var)
#comparisons
round(cbind(mean(v),1/12),4)
round(cbind(var(v),1/(180*n)),6)
se <- sqrt(1/(180*n))
round(cbind(sd(v),se),4)


#Bootstrap analysis
#blood pressure data -- matched case/control pairs data
#data
before <- c(130,122,124,104,112,101,121,124,115,102,98,119,106,107,100)
after <- c(105,112,112,106,110,105,90,95,103,98,118,108,110,108,102)
n <- length(before)
P <- 100*(before-after)/before  #percent decrease
cbind(before,after,P)
mean(P)

#statistical properties of the percentage decrease (denoted P)
#bootstrap mean, variance, confidence interval
iter <- 5000
m.temp <- matrix(sample(P,n*iter,replace=TRUE),n,iter)
dim(m.temp)
ptemp <- apply(m.temp,2,mean)
Pbar <- mean(ptemp)
se <- sd(ptemp)
round(cbind(Pbar,se),3)

#confidence intervals
P0 <- sort(ptemp)
lower <- P0[iter*0.025]
upper <- P0[iter*0.975]
round(cbind(lower,Pbar,upper),3) #nonparametric

LOWER <- Pbar-1.960*se
UPPER <- Pbar+1.960*se
round(cbind(LOWER,Pbar,UPPER),3) #parametric

#evaluations
Pvalue <- 2*sum(ifelse(ptemp<0,1,0))/iter  #nonparametric  
z <- Pbar/se
pvalue <- 2*(1-abs(pnorm(z))) #parametric 
round(cbind(Pvalue,z,pvalue),3)

#two plots of estimated distribution
hist(ptemp,50,main="Blood pressure trial data",xlab="Percent change")
plot(density(ptemp,0.5),xlab="percent change",ylim=c(0,.15),main="percent decease -- case/control data")

