
#lesson.8.r
#function list:  attributes, t.test, lm

#R-routines generate an "object" containing relevant values from the 
#applied R-function that can be retrieved and used in further analyses

#example 1 -- attributes t-test
#data
n <- 100
x0 <- rnorm(n,0,2)
x1 <- rnorm(n,4,2)

#analysis
f <- t.test(x1,x0)
attributes(f)
round(c(f$statistic,f$parameter,f$p.value),3)
f$conf.int
f$estimate

t.test(x1,x0)

#example 2 -- attributes -- linear model
#data
set.seed(777) #always produces the same "random values"
x1 <- c(1,2,7,1,10,3,1,9,5,3,1,5,4,9,7,5,5,3,7,8)
x2 <- c(5,2,8,1,10,5,5,1,4,7,6,3,9,2,6,8,7,7,7,6)
n <- 20
y <- 10+2*x1+4*x2+rnorm(n,6)

f <- glm(y~x1+x2)  #glm = general linear model
attributes(f)
f$formula
f$coefficients
fit <- f$fitted.values
round(rbind(x1,x2,y,fit),1)

res <- f$residuals
res.dev <- sum(res^2)
res.dev
cor(y,fit)^2
b <- f$coefficients
se <- summary(f)$coefficients[,2]
z <- b/se
pvalue <- summary(f)$coefficients[,4]
round(cbind(b,se,z,pvalue),4)
summary(f)
plot(sort(y),sort(fit),type="b",main="goodness of fit -- linear?")
abline(0,1)
summary(f)
