#lesson.9.r
#eight examples of R-graphics
#postscript("file.name",height=value,width=value,horizontal=FALSE) -- details enter ?postscript
#the postscript command creates a file (<file.name>.ps) that is saved and can be printed

#example 1
#graphic comparison of sample data to a normal distribution
n <- 200
m <- 10
s <- 2
x <- rnorm(n,m,s)
xbar <- mean(x)
sd <- sd(x)

#version 1 -- probability distributions
#cat -- number of categories
#freq -- TRUE = probabilities/proportions and FALSE = counts are plotted
#lwd increases the line width using lwd=value (1 is default)
#main = title of plot
#xlab = label for the x-axes
cat <- 30   #sets the number of categories
hist(x,cat,freq=FALSE,xlab="test values x",
main="Comparison of probability distributions")
z <- seq(min(x)-2*s,max(x+2*s),.1)
lines(z,dnorm(z,xbar,sd),lwd=2)

#version 2 -- cumulative distributions 
cdf <- (1:n)/n
plot(sort(x),cdf,type="l",xlab="test values x",
main="Comparison of cumulative distributions")
lines(z,pnorm(z,xbar,sd),lwd=2)

#example 2
#four log-normal distributions
#two plots printed on one page
par(mfrow=c(1,2))
#creates square plots
par(pty="s")
m <- .5  #mean value
s <- .5  #standard deviation
z <- seq(0,15,.1)

#type="l" -- plots lines
#xlab and ylab labels the axes
#xlim and ylim determine the x/y-plot limits

#three lognormal distributions
plot(z,dlnorm(z,m,s),type="l",xlim=c(0,12),xlab="Observations Y",ylab="")
title("Lognormal distributions")
lines(z,dlnorm(z,m,s),lty=2)
s <- 1.5
lines(z,dlnorm(z,m,s),lty=3)
m <- 2
lines(z,dlnorm(z,m,s),lty=4)
  
#the three corresponding normal distributions
z <- seq(-2,5,.1)
m <- 0
s <- 0.5
plot(z,dnorm(z,m,s),type="l",xlim=c(-2,5),xlab="Observations Y",ylab="")
title("normal distributions")
m <- 1
lines(z,dnorm(z,m,s),lty=2)
m <- 2
lines(z,dnorm(z,m,s),lty=3)


# few choices for plot symbols
par(mfrow=c(1,1))
plot(1:20,rep(5,20),pch=1:20,axes=FALSE,xlab="",ylab="")
text(1:20,rep(4.8,20),1:20)
text(10,5.3,"a few choices for plot symbols")


#example 3
#plot a matrix -- loglinear.example
#counts of new born infants with birth defects
#for different ethnic groups

par(mfrow=c(1,1))
d <- c(50,84,48,14,18,16,22,30,17,39,32,41)
D <- matrix(log(d),3,4)
D
#produces one plot per page --- default
par(mfrow=c(1,1))
#xlim defines the range of x
#pch = 1 -- plot symbol = o
#type = "b" plots both points and lines
#xlim defines the range of x
#ylim defines the range of y
matplot(1:3,D,type="b",xlab="Categories (vitamin use)",ylab="Log-frequencies",ylim=c(2.2,4.5))

#plots labels located at points x and y -- text(x,y,"label")
text(2.5,4.3,"white")
text(2.5,3.75,"Asian")
text(2.5,3.25,"Hispanic")
text(2.5,2.9,"African-American")
text(1.15,2.20,"always")
text(2.05,2.20,"during")
text(2.85,2.20,"never")
title("Log-counts of infants with birth defects")

#example 4
#expected years of life by state classified 
#as urban and non-urban status

#data
exwm <- c(66.17,67.25,65.69,66.68,66.86,68.40,67.06,67.24,66.97,68.53,68.16,68.96,66.98,66.24,66.70,67.32,67.97,66.16,67.60,67.27,67.95,66.75,66.35,67.93,68.93,67.48,69.07,65.35,67.35,67.80,67.42,68.71,65.16,67.57,67.38,66.19,67.49,68.87,68.03,65.88,65.74,67.24,70.39,67.32,68.02,67.72,66.74,65.70,67.20,68.53,68.71)
exwf <- c(74.35,73.81,72.83,74.31,74.31,74.98,73.84,74.36,74.19,75.24,73.98,75.18,74.74,73.60,73.73,74.27,74.27,73.93,73.70,74.38,74.53,73.42,74.33,74.56,74.88,74.16,75.59,72.82,74.04,74.20,73.82,74.75,72.77,73.94,74.59,74.08,74.85,75.26,74.75,74.08,74.06,73.47,75.68,74.17,74.16,74.82,74.08,73.67,73.70,75.23,75.27)
urban <- c(58.4,64.9,80.9,58.8,48.8,57.2,56.5,79.8,79.5,66.1,88.9,80.6,50.0,52.4,70.0,32.2,90.9,66.1,85.6,63.1,78.7,50.9,45.0,72.6,77.3,76.6,44.3,39.0,72.1,84.6,75.3,65.9,100.0,73.9,68.0,60.4,80.5,66.4,67.1,60.3,44.5,71.5,83.0,70.1,87.0,54.3,53.6,47.6,83.0,61.6,44.6)

#pch = choice of plot symbol
par(mfrow=c(1,1))
plot(exwf[urban<75],exwm[urban<75],pch="+",
ylim=c(min(exwm),max(exwm)),xlim=c(min(exwf),max(exwf)),
ylab="expectation of life (wm)",
xlab="expectation of life (wf)")
title("Expectation of life -- males versus females")
#plots points -- data by percent urban
points(exwf[urban>=75],exwm[urban>=75],pch="o")
#plots a line with intercept a and slope b --abline(a,b)
abline(lsfit(exwf,exwm)$coef)
#plots centroid values for urban data -- <75 versus >=75
points(mean(exwf[urban<75]),mean(exwm[urban<75]),pch="x",cex=1.5)
points(mean(exwf[urban>=75]),mean(exwm[urban>=75]),pch="*",cex=2.5)
#legend with upper left corner located at x=73 and y=70)
legend(73,70,c("%urban < 75","%urban >= 75",
"non-urban centroid","urban centroid"),pch="+ox*")

#example 5
#plot of heterozygotic frequencies by allele frequency
#for the range of p
p <- seq(0,1,.02)
q <- 1-p
#cex determines font size -- cex = 1 is default
plot(p,2*p*q,type="l",ylim=c(0,0.55),xlab="Allele frequency p",ylab="H = 2pq",cex.lab=1.3)
text(.5,.52,"F = 0")
F <- 0.5
lines(p,2*(1-F)*p*q,lty=2)
text(.5,2*(1-F)*.25-.03,"F = 0.5")
F <- 0.7
lines(p,2*(1-F)*p*q,lty=3)
text(.5,2*(1-F)*.25-.03,"F = 0.7")
F <- 0.9
lines(p,2*(1-F)*p*q,lty=3)
text(.5,2*(1-F)*.25-.02,"F = 0.9")
title("Frequency of heterozygotic (H)")

#example 6
#receiver operation characteristic ("roc-curve")
roc <- function(a,b) {
s <- 2
c <- seq(0,a+3*s,0.1)
f <- dnorm(c,a,s)
plot(c,f,type="l",xlab="Observed test values",yaxt="n",ylab="")
f <- dnorm(c,b,s)
lines(c,f)
fpf <- 1-pnorm(c,b,s)
tpf <- 1-pnorm(c,a,s)
title("Normal distributions")

plot(fpf,tpf,type="l",ylab="True positive fraction",
xlab="False positive fraction")
abline(0,1,lty=2)
title("ROC curve")
}

#six plots -- 3 rows and 2 columns
par(mfrow=c(3,2))
par(pty="s")
roc(10,9)
roc(10,8)
roc(10,5)

#example 7
#htwt.3d.r -- three dimensional plots
par(pty="s")
par(mfrow=c(1,1))

#polynomial to be displayed
fcn <- function(ht,wt) {
ht2 <- ht^2
wt2 <- wt^2
bwt <- 1220.5+8.05*ht+26.240*wt-0.0077*ht2-0.107*wt2
}

W <- seq(30,120,length=50)
H <- seq(100,200,length=50)
Z <- outer(H,W,fcn)

persp(W,H,Z,xlab="weight",ylab="height",zlab="birth weight")
title("BIRTH WEIGHT by maternal height and weight")

#theta determines the prospective
persp(W,H,Z,theta=-90,xlab="weight",ylab="height",zlab="birth weight")
title("Birth weight by maternal height and weight")

persp(W,H,Z,theta=-135,xlab="weight",ylab="height",zlab="birth weight")
title("Birth weight by maternal height and weight")

#example 8
#displays the point of "chaos"
#creates four plots for different values of g on the same page

mplot <- function(g) {
n <- 15
f <- 0.01
for(i in 1:(n-1)) {
f[i+1] <- g*f[i]*(1-f[i])
}
#paste yields output combining numeric and non-numeric values
plot(1:n,f,type="l",xlab="time",ylab="F")
temp <- paste("F=",g,"*f*(1-f)")
title(temp,cex=.8)
}

par(mfrow=c(2,2))
mplot(0.5)
mplot(1.5)
mplot(2.5)
mplot(3.5)

#example 9
#smoking data
#detailed plot of linear model of smoking exposure data
par(mfrow=c(1,1))  #one plot per page (default)
par(pty="s")
a <- -2.764; b1 <- 0.412; b2 <- 0.804; b3 <- 0.894
y <- c(a,a+b1,a+b2,a+b3)
x <- c(0,10,20,30)
plot(x,y,ylim=c(-2.8,-1.7),xlab="smoking exposure",
ylab="log-odds",xlim=c(-0.5,40),cex.lab=1.7)
lines(x,y,lty=2)
abline(-2.725,0.0325)
text(4,y[1],y[1],cex=1.0)
text(10-4,y[2],y[2],cex=1.0)
text(20-4,y[3],paste(-1.960,"0",sep=""),cex=1.0)
text(30.+4,y[4],paste(-1.87,"0",sep=""),cex=1.0)
text(25,-2.6,"line: -2.725 + 0.0325F",cex=1.0)
arrows(18.0,-2.6,11,-2.4,length=0.1)
abline(h=a,lty=3)
lines(c(10,10),c(a,y[2]),lty=3)
lines(c(20,20),c(a,y[3]),lty=3)
lines(c(30,30),c(a,y[4]),lty=3)
#?plotmath for documentation of the function "expression"
text(15.5,-2.5,expression(paste(hat(b) [1]," = 0.412")))
text(25.5,-2.3,expression(paste(hat(b) [2]," = 0.804")))
text(35.5,-2.1,expression(paste(hat(b) [3]," = 0.894")))
legend(5,-1.7,c("saturated model","linear model"),lty=2:1)


